org.apache.pdfbox.pdmodel.graphics.color

## Class PDDeviceRGB

- java.lang.Object
- - org.apache.pdfbox.pdmodel.graphics.color.PDColorSpace
  - - org.apache.pdfbox.pdmodel.graphics.color.PDDeviceColorSpace
    - - org.apache.pdfbox.pdmodel.graphics.color.PDDeviceRGB

All Implemented Interfaces:
  COSObjectable

    public final class PDDeviceRGB
    extends PDDeviceColorSpace

Colours in the DeviceRGB colour space are specified according to the additive RGB (red-green-blue) colour model.

Author:
  Ben Litchfield, John Hewson

### Field Summary

Fields
`static PDDeviceRGB` `INSTANCE` This is the single instance of this class.

### Fields inherited from class org.apache.pdfbox.pdmodel.graphics.color.PDColorSpace

`array`

### Method Summary

All Methods Instance Methods Concrete Methods
`float[]` `getDefaultDecode(int bitsPerComponent)` Returns the default decode array for this color space.
`PDColor` `getInitialColor()` Returns the initial color value for this color space.
`String` `getName()` Returns the name of the color space.
`int` `getNumberOfComponents()` Returns the number of components in this color space
`BufferedImage` `toRawImage(WritableRaster raster)` Returns the image in this colorspace or null.
`float[]` `toRGB(float[] value)` Returns the RGB equivalent of the given color value.
`BufferedImage` `toRGBImage(WritableRaster raster)` Returns the (A)RGB equivalent of the given raster.

### Methods inherited from class org.apache.pdfbox.pdmodel.graphics.color.PDDeviceColorSpace

`getCOSObject, toString`

### Methods inherited from class org.apache.pdfbox.pdmodel.graphics.color.PDColorSpace

`create, create, create, toRawImage, toRGBImageAWT`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### INSTANCE

    public static final PDDeviceRGB INSTANCE

This is the single instance of this class.

### Method Detail

#### getName

    public String getName()

Description copied from class: `PDColorSpace`
Returns the name of the color space.

Specified by:
  `getName` in class `PDColorSpace`
Returns:
  the name of the color space

#### getNumberOfComponents

    public int getNumberOfComponents()

Returns the number of components in this color space

Specified by:
  `getNumberOfComponents` in class `PDColorSpace`
Returns:
  the number of components in this color space

#### getDefaultDecode

    public float[] getDefaultDecode(int bitsPerComponent)

Description copied from class: `PDColorSpace`
Returns the default decode array for this color space.

Specified by:
  `getDefaultDecode` in class `PDColorSpace`
Parameters:
  `bitsPerComponent` - the number of bits per component.
Returns:
  the default decode array

#### getInitialColor

    public PDColor getInitialColor()

Description copied from class: `PDColorSpace`
Returns the initial color value for this color space.

Specified by:
  `getInitialColor` in class `PDColorSpace`
Returns:
  the initial color value for this color space

#### toRGB

    public float[] toRGB(float[] value)

Description copied from class: `PDColorSpace`
Returns the RGB equivalent of the given color value.

Specified by:
  `toRGB` in class `PDColorSpace`
Parameters:
  `value` - a color value with component values between 0 and 1
Returns:
  an array of R,G,B value between 0 and 255

#### toRGBImage

    public BufferedImage toRGBImage(WritableRaster raster)
                             throws IOException

Description copied from class: `PDColorSpace`
Returns the (A)RGB equivalent of the given raster.

Specified by:
  `toRGBImage` in class `PDColorSpace`
Parameters:
  `raster` - the source raster
Returns:
  an (A)RGB buffered image
Throws:
  `IOException` - if the color conversion fails

#### toRawImage

    public BufferedImage toRawImage(WritableRaster raster)
                             throws IOException

Description copied from class: `PDColorSpace`
Returns the image in this colorspace or null. No conversion is performed. For special colorspaces like PDSeparation the image is returned in the gray colorspace. For undefined colorspaces like DeviceCMYK/DeviceRGB and DeviceGray null is returned. You can always fallback to `PDColorSpace.toRGBImage(WritableRaster)` if this returns null.

Specified by:
  `toRawImage` in class `PDColorSpace`
Parameters:
  `raster` - the source raster
Returns:
  an buffered image in this colorspace. Or null if it is not possible to extract that image with the original colorspace without conversion.
Throws:
  `IOException` - if the image conversion fails